## Fixes

- fixed protective stop loss for long position.
- fixed trailing stop for long position.
- fixed trade collector concurrent write issue.
- fixed cpu profile starter.
- fixed rbtree and add panic check.
- fixed binance futures trade, position and order type conversion.

## Features

- added telegram photo upload support.
- added multi-symbol support to active order book and trade collector.
- added max/binance query order service support.
- added binance QueryOrderTrades API
- added ftx order amount fee conversion.
- added default fee rate to FTX exchange.
- added leverage/risk calculator.
- optimizer: calculate equity diff from whole assets instead of first symbol.
- added optimizeex command, a hyperparameter optimization tool

## Strategies Updates

- autoborrow: add debtRatio
- drift: added smart cancel, fixed position bugs, added multiple level trailing stop, removed takeProftFactor, use fisher transform, added 1m drift for takeprofit/stoploss, rebalance position according to the trendline.
- supertrend: output profit stats and calculate quantity by risk/leverage.
- pivotshort: added trendema and fixed initial ema value.
- pivotshort: added SideEffectTypeAutoRepay to pivotshort take-profit order
- factorzoo: integrated logistic regression, indicator refactoring and updates.

[Full Changelog](https://github.com/c9s/bbgo/compare/v1.38.0...main)

 - [#882](https://github.com/c9s/bbgo/pull/882): strategy/autoborrow: add debt re-balancing
 - [#877](https://github.com/c9s/bbgo/pull/877): strategy/supertrend: update example config
 - [#878](https://github.com/c9s/bbgo/pull/878): Drift rebase
 - [#875](https://github.com/c9s/bbgo/pull/875): pivotshort: trendema add initial date
 - [#876](https://github.com/c9s/bbgo/pull/876): Fix: risk.AvailableQuote() should use Net() to get net value
 - [#874](https://github.com/c9s/bbgo/pull/874): Fix binance futures
 - [#872](https://github.com/c9s/bbgo/pull/872): fix: trailing stop properly works on both long and short positions
 - [#873](https://github.com/c9s/bbgo/pull/873): improve: generalorderexecutor retries submit/cancel order once
 - [#871](https://github.com/c9s/bbgo/pull/871): improve: improve maxapi, add v2 order api back
 - [#869](https://github.com/c9s/bbgo/pull/869): Revert "feature: add smart cancel to drift"
 - [#853](https://github.com/c9s/bbgo/pull/853): feature: add smart cancel to drift
 - [#860](https://github.com/c9s/bbgo/pull/860): exchange: order fee-amount protection
 - [#865](https://github.com/c9s/bbgo/pull/865): fix: protectivestoploss not working on long position
 - [#868](https://github.com/c9s/bbgo/pull/868): fix: many minor fixes
 - [#867](https://github.com/c9s/bbgo/pull/867): strategy: factorzoo: upgrade indicators and add comments
 - [#862](https://github.com/c9s/bbgo/pull/862): Improve: supertrend strategy
 - [#863](https://github.com/c9s/bbgo/pull/863): types: rbtree: resolve neel reusing problem
 - [#852](https://github.com/c9s/bbgo/pull/852): feature: PositionModifier
 - [#861](https://github.com/c9s/bbgo/pull/861): strategy/supertrend: re-organize exits part of config
 - [#855](https://github.com/c9s/bbgo/pull/855): optimizeex: hyperparameter optimization tool
 - [#856](https://github.com/c9s/bbgo/pull/856): exchange: FTX default fee
 - [#857](https://github.com/c9s/bbgo/pull/857): optimizer: calculate equity diff from whole assets instead of first symbol
 - [#854](https://github.com/c9s/bbgo/pull/854): fix: added SideEffectTypeAutoRepay to pivotshort take-profit order
